function [t,x] = RK4(t0,x0,h,F)

t = t0 + h;
k1 = F(t0,x0);
k2 = F(t0 + h/2, x0 + h.*k1./2);
k3 = F(t0 + h/2, x0 + h.*k2./2);
k4 = F(t0 + h, x0 + h.*k3);

x = x0 + (h/6).*(k1 + 2.*k2 + 2.*k3 + k4);


end