
% Choose integration Method
Method = 2;

syms x y

sf = symfun(x.^2 + y.^2,[x y]);
f = matlabFunction(sf);

sGradf = [diff(f,x),diff(f,y)];
Gradf = matlabFunction(sGradf);

sTanGradf = [-diff(f,y),diff(f,x)];
TanGradf = matlabFunction(sTanGradf);

sin = @(x,y) y/sqrt(f(x,y));

xt = 1; yt = 0;
Xp = xt;
Yp = yt;
t = 0;
h = 0.15;

C = f(x,y);

flag = 0;


if Method == 1
    Integration = @(t,xt,yt) Euler(t,xt,yt,h,TanGradf);
elseif Method == 2 
    Integration = @(t,xt,yt) RK2(t,xt,yt,h,TanGradf);
elseif Method == 3
    Integration = @(t,xt,yt) RK3(t,xt,yt,h,TanGradf);
elseif Method == 4;
    Integration = @(t,xt,yt) RK4(t,xt,yt,h,TanGradf);
end
tempo = [];
Nivel = [];
%figure; hold on

while flag < 2

    [t,xtnew,ytnew] = Integration(t,xt,yt);
    %plot(xtnew,ytnew,'*')
    %pause(0.1)
    
    if sign(sin(xtnew,ytnew)) > sign(sin(xt,yt))
        flag = flag + 1;
    end
    tempo = [tempo;t];
    Nivel = [Nivel;f(xtnew,ytnew)];
    
    xt = xtnew;
    yt = ytnew;
    
    Xp = [Xp;xt];
    Yp = [Yp;yt];

end

figure; 
plot(Xp,Yp)
    xlabel('x'); ylabel('y')
    xlim([-1.2,1.2])
    ylim([-1.2,1.2])
    if Method == 1
        title(sprintf('Metodo de Euler, h = %f',h));
    elseif Method == 2
        title(sprintf('Metodo RK2, h = %f',h));
    elseif Method == 3
        title(sprintf('Metodo RK3, h = %f',h));
    elseif Method == 4
        title(sprintf('Metodo RK4, h = %f',h));
    end

figure; plot(tempo,Nivel)
xlabel('t'); ylabel('f(x(t),y(t))')
    if Method == 1
        title(sprintf('f(x(t),y(t)) usando Metodo de Euler, h = %f',h));
    elseif Method == 2
        title(sprintf('f(x(t),y(t)) usando Metodo RK2, h = %f',h));
    elseif Method == 3
        title(sprintf('f(x(t),y(t)) usando Metodo RK3, h = %f',h));
    elseif Method == 4
        title(sprintf('f(x(t),y(t)) usando Metodo RK4, h = %f',h));
    end