function [t,x,y] = RK3(t,x,y,h,Func)

z = [x,y];

k1 = Func(x,y);
k2 = Func(x + 0.5.*h.*k1(1),y + 0.5.*h.*k1(2));
k3 = Func(x + 0.75.*h.*k2(1),y + 0.75.*h.*k2(2));

z = z + (h/9).*(2.*k1 + 3.*k2 + 4.*k3);

t = t+h;
x = z(1) ; y = z(2);

end