
% Choose integration Method
Method = 4;

syms x y

sf = symfun(0.004 +0.110*x -0.177*y -0.174*x^2 +0.224*x*y -0.303*y^2 ...
-0.168*x^3 +0.327*x^2*y -0.087*x*y^2 -0.013*y^3 +0.235*x^4 ...
-0.667*x^3*y +0.745*x^2*y^2 -0.029*x*y^3 +0.072*y^4,[x y]);
f = matlabFunction(sf);

sGradf = [diff(f,x),diff(f,y)];
Gradf = matlabFunction(sGradf);

sTanGradf = [-diff(f,y),diff(f,x)];
TanGradf = matlabFunction(sTanGradf);

sin = @(x,y) y/sqrt(f(x,y));

xt = 1; yt = 0;
Xp = xt;
Yp = yt;
t = 0;
h = 0.05;

C = f(xt,yt);

flag = 0;

tempo = [];
Nivel = [];


if Method == 1
    Integration = @(t,xt,yt) Euler(t,xt,yt,h,TanGradf);
elseif Method == 2 
    Integration = @(t,xt,yt) RK2(t,xt,yt,h,TanGradf);
elseif Method == 3
    Integration = @(t,xt,yt) RK3(t,xt,yt,h,TanGradf);
elseif Method == 4;
    Integration = @(t,xt,yt) RK4(t,xt,yt,h,TanGradf);
end

%figure; hold on

while flag < 3

    [t,xtnew,ytnew] = Integration(t,xt,yt);
    %plot(xtnew,ytnew,'*')
    %pause(0.1)
    
    if sign(sin(xtnew,ytnew)) > sign(sin(xt,yt))
        flag = flag + 1;
    end
    
    tempo = [tempo;t];
    Nivel = [Nivel;f(xtnew,ytnew)];
    
    xt = xtnew;
    yt = ytnew;
    
    Xp = [Xp;xt];
    Yp = [Yp;yt];
    
end

figure; 
plot(Xp,Yp)
    xlabel('x'); ylabel('y')
    xlim([-1.5,1.5])
    ylim([-2,3])
    if Method == 1
        title(sprintf('Metodo de Euler, h = %f',h));
    elseif Method == 2
        title(sprintf('Metodo RK2, h = %f',h));
    elseif Method == 3
        title(sprintf('Metodo RK3, h = %f',h));
    elseif Method == 4
        title(sprintf('Metodo RK4, h = %f',h));
    end

figure; plot(tempo,Nivel)
xlabel('t'); ylabel('f(x(t),y(t))')
    if Method == 1
        title(sprintf('f(x(t),y(t)) usando Metodo de Euler, h = %f',h));
    elseif Method == 2
        title(sprintf('f(x(t),y(t)) usando Metodo RK2, h = %f',h));
    elseif Method == 3
        title(sprintf('f(x(t),y(t)) usando Metodo RK3, h = %f',h));
    elseif Method == 4
        title(sprintf('f(x(t),y(t)) usando Metodo RK4, h = %f',h));
    end