
% Choose integration Method
Method = 1;
CorrectionTol = 1e-5;
syms x y

sf = symfun(0.004 +0.110*x -0.177*y -0.174*x^2 +0.224*x*y -0.303*y^2 ...
-0.168*x^3 +0.327*x^2*y -0.087*x*y^2 -0.013*y^3 +0.235*x^4 ...
-0.667*x^3*y +0.745*x^2*y^2 -0.029*x*y^3 +0.072*y^4,[x y]);
f = matlabFunction(sf);

sGradf = [diff(f,x),diff(f,y)];
Gradf = matlabFunction(sGradf);

sTanGradf = [-diff(f,y),diff(f,x)];
TanGradf = matlabFunction(sTanGradf);

sin = @(x,y) y/sqrt(f(x,y));

xt = 1; yt = 0;
t = 0;
h = 0.01;

C = f(xt,yt);

flag = 0;


if Method == 1
    Integration = @(t,xt,yt) Euler(t,xt,yt,h,TanGradf);
elseif Method == 2 
    Integration = @(t,xt,yt) RK2(t,xt,yt,h,TanGradf);
elseif Method == 3
    Integration = @(t,xt,yt) RK3(t,xt,yt,h,TanGradf);
elseif Method == 4;
    Integration = @(t,xt,yt) RK4(t,xt,yt,h,TanGradf);
end

figure; hold on

while flag < 20
    
    [t,xtnew,ytnew] = Integration(t,xt,yt);
    %f(xtnew,ytnew)
    Direction = @(r) r.*Gradf(xtnew,ytnew)./sqrt(Gradf(xtnew,ytnew)*Gradf(xtnew,ytnew)'); 
    %Direction = @(rs) rs.*Gradf(xt,yt)./sqrt(Gradf(xt,yt)*Gradf(xt,yt)'); 
    syms r
    Cnew = f(xtnew,ytnew);
    
    
    if abs(Cnew - C) > CorrectionTol
        srestf = subs(sf - C,x,r*xtnew); srestf = subs(srestf,y,r*ytnew);
        restf = matlabFunction(srestf);
        restf = @(r) restf(xtnew,ytnew,r);%./(restf(xtnew,ytnew,r)*restf(xtnew,ytnew,r)');
        %srestGradf = subs(sGradf,x,r*xt); srestGradf = subs(srestGradf,y,r*yt);
        srestGradf = diff(srestf,r);
        restGradf = matlabFunction(srestGradf);    
        restGradf = @(r) restGradf(xtnew,ytnew,r);
        rnew = 2;
        while abs(Cnew) > CorrectionTol
            [rnew] = Newton(rnew,restf,restGradf);
            Cnew = sqrt(restf(rnew))
        end
        znew = Direction(rnew);
        xtnew = znew(1); ytnew = znew(2);
        Cnew = f(xtnew,ytnew);
    end
    plot(xtnew,ytnew,'*')
    pause(0.1)    
    
    if sign(sin(xtnew,ytnew)) > sign(sin(xt,yt))
        flag = flag + 1;
    end
    
    xt = xtnew;
    yt = ytnew;
    
end