function [t,x,y] = RK4(t,x,y,h,Func)

z = [x,y];

k1 = Func(x,y);
k2 = Func(x + 0.5.*h.*k1(1),y + 0.5.*h.*k1(2));
k3 = Func(x + 0.5.*h.*k2(1),y + 0.5.*h.*k2(2));
k4 = Func(x + h.*k3(1),y + h.*k3(2));

z = z + (h/6).*(k1+2.*k2+2.*k3+k4);
x = z(1); y = z(2);

t = t+h;

end