
% Choose integration Method
Method = 4;

syms x y

sf = symfun(y^2 - x^3 - x,[x y]);
f = matlabFunction(sf);

sGradf = [diff(f,x),diff(f,y)];
Gradf = matlabFunction(sGradf);

sTanGradf = [-diff(f,y),diff(f,x)];
TanGradf = matlabFunction(sTanGradf);

sin = @(x,y) y/sqrt(f(x,y));

xt = 1; yt = 4;
Xp = xt;
Yp = yt;
t = 0;
h = 0.05;

C = f(xt,yt);

flag = 0;

tempo = [];
Nivel = [];

if Method == 1
    Integration = @(t,xt,yt) Euler(t,xt,yt,h,TanGradf);
elseif Method == 2 
    Integration = @(t,xt,yt) RK2(t,xt,yt,h,TanGradf);
elseif Method == 3
    Integration = @(t,xt,yt) RK3(t,xt,yt,h,TanGradf);
elseif Method == 4;
    Integration = @(t,xt,yt) RK4(t,xt,yt,h,TanGradf);
end

%figure; hold on

while flag < 1

    [t,xtnew,ytnew] = Integration(t,xt,yt);
    %plot(xtnew,ytnew,'*')
    %pause(0.1)
    
    if xt>1
        flag = flag + 1;
    end
    tempo = [tempo;t];
    Nivel = [Nivel;f(xtnew,ytnew)];
    
    xt = xtnew;
    yt = ytnew;
    
    Xp = [Xp;xt];
    Yp = [Yp;yt];
    
end


figure; 
plot(Xp,Yp)
    xlabel('x'); ylabel('y')
    xlim([-2.5,1])
    ylim([-4.5,4.5])
    if Method == 1
        title(sprintf('Metodo de Euler, h = %f',h));
    elseif Method == 2
        title(sprintf('Metodo RK2, h = %f',h));
    elseif Method == 3
        title(sprintf('Metodo RK3, h = %f',h));
    elseif Method == 4
        title(sprintf('Metodo RK4, h = %f',h));
    end

figure; plot(tempo,Nivel)
xlabel('t'); ylabel('f(x(t),y(t))')
    if Method == 1
        title(sprintf('f(x(t),y(t)) usando Metodo de Euler, h = %f',h));
    elseif Method == 2
        title(sprintf('f(x(t),y(t)) usando Metodo RK2, h = %f',h));
    elseif Method == 3
        title(sprintf('f(x(t),y(t)) usando Metodo RK3, h = %f',h));
    elseif Method == 4
        title(sprintf('f(x(t),y(t)) usando Metodo RK4, h = %f',h));
    end