
% Choose integration Method
Method = 3;
CorrectionTol = 1e-10;
syms x y

sf = symfun(y^2 - x.^3 -x,[x y]);
f = matlabFunction(sf);

sGradf = [diff(f,x),diff(f,y)];
Gradf = matlabFunction(sGradf);

sTanGradf = [-diff(f,y),diff(f,x)];
TanGradf = matlabFunction(sTanGradf);

sin = @(x,y) y/sqrt(f(x,y));

xt = 1; yt = 2;
t = 0;
h = 0.01;

C = f(xt,yt);

flag = 0;


if Method == 1
    Integration = @(t,xt,yt) Euler(t,xt,yt,h,TanGradf);
elseif Method == 2 
    Integration = @(t,xt,yt) RK2(t,xt,yt,h,TanGradf);
elseif Method == 3
    Integration = @(t,xt,yt) RK3(t,xt,yt,h,TanGradf);
elseif Method == 4;
    Integration = @(t,xt,yt) RK4(t,xt,yt,h,TanGradf);
end

figure; hold on

while flag < 2
    
    [t,xtnew,ytnew] = Integration(t,xt,yt);
    %f(xtnew,ytnew)
    Direction = @(r) r.*Gradf(xtnew,ytnew)./sqrt(Gradf(xtnew,ytnew)*Gradf(xtnew,ytnew)'); 
    %Direction = @(r) r.*Gradf(xt,yt)./sqrt(Gradf(xt,yt)*Gradf(xt,yt)'); 
    syms r
    Cnew = f(xtnew,ytnew);
    
    
    if abs(Cnew - C) > CorrectionTol
        srestf = subs(sf - C,x,r*xtnew); srestf = subs(srestf,y,r*ytnew);
        restf = matlabFunction(srestf);
        restf = @(r) restf(xtnew,ytnew,r);%./(restf(xtnew,ytnew,r)*restf(xtnew,ytnew,r)');
        %srestGradf = subs(sGradf,x,r*xt); srestGradf = subs(srestGradf,y,r*yt);
        srestGradf = diff(srestf,r);
        restGradf = matlabFunction(srestGradf);    
        restGradf = @(r) restGradf(xtnew,ytnew,r);
        rnew = 1;
        while abs(Cnew) > CorrectionTol
            [rnew] = Newton(rnew,restf,restGradf);
            Cnew = restf(rnew)
        end
        znew = Direction(rnew);
        xtnew = znew(1); ytnew = znew(2);
        Cnew = f(xtnew,ytnew);
    end
    plot(xtnew,ytnew,'*')
    pause(0.1)    
    
    if sign(sin(xtnew,ytnew)) > sign(sin(xt,yt))
        flag = flag + 1;
    end
    
    xt = xtnew;
    yt = ytnew;
    
end