function [] = Exemplo19

% Parametros de iteracao
Tol = 1e-30;
erro = 1;
counter = 0;
counterMax = 50;

% Solucao Analitica do PVI
sol = @(t) exp(t.^2);

% Definicao do PVI
F = @(t,x) 2.*t.*x;
xi = 1;

%
stepgen = 0.01;
t = 0:stepgen:1;

X0 = ones(1,max(size(t)));
    
Integrador = @(x) Retangulo(t,x,F);
%Integrador = @(x) Trapezio(t,x,F);

Passo = @(X0) Iterado(X0,t,F,xi,Integrador); 
   
while erro > Tol
    counter = counter + 1;
    X = Passo(X0);
    erro = Norma(X - X0);
    X0 = X;
    
    plot(t,sol(t),t,X)
    title(sprintf('Iterado n = %f',counter));
    pause(0.2)
    
    if counter > counterMax
        break
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%>>> FUNCOES AUXILIARES <<<%%%%%%%%%%%%%%%%%%%%%%%%
%>>>> Iterado de Picard
    function X = Iterado(X0,t,Func,xi,Integrador)

    Fstep = Func(t,X0);
    step = [0, t(2:end) - t(1:end-1)];
    X = xi + Integrador(X0);

    end

%>>>> Norma do expaco metrico
    function Y = Norma(y)

    Y = max(abs(y));

    end

%>>>> Integrador Numerico
    function Z1 = Retangulo(t,X0,Func)
        
            Fstep = Func(t,X0);
            step = [0, t(2:end) - t(1:end-1)];
            Z1 = cumsum(step.*Fstep);
    end

    function Z2 = Trapezio(t,X0,Func)
        
            Fstep = ([Func(t(2:end),X0(2:end)),0] + [0,Func(t(1:end-1),X0(1:end-1))])./2;
            step = [0, t(2:end) - t(1:end-1)];
            Z2 = cumsum(step.*Fstep);
        
    end
end

